#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
gboolean disp_section=FALSE;
gboolean disp_symbol=FALSE;
gboolean eu_readelf=FALSE;

void
on_readELF_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if(gtk_toggle_button_get_active(togglebutton))
   	eu_readelf=TRUE;
	else
	eu_readelf=FALSE;
}

void
on_section_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
// The section should be displayed
	if(gtk_toggle_button_get_active(togglebutton))
	disp_section=TRUE;
	else
	disp_section=FALSE; 
}


void
on_symbol_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//the symbols should be displayed
	if(gtk_toggle_button_get_active(togglebutton))
	disp_symbol=TRUE;
	else
	disp_symbol=FALSE;
}


void
on_start_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
    //call the ELF file parser and send output to textview1
    GError *error;
    gboolean res;
    GIOChannel *my_channel;
    GIOStatus stat;
    gsize length,ter_pos;
    int fd,status;
    FILE *fp;
	gchar *filename;
    gchar my_command[1024];
    gchar *my_params=NULL;
    
    filename=malloc(sizeof(char)*strlen(gtk_file_chooser_get_filename(filechooserbutton1)+1));
    filename=gtk_file_chooser_get_filename(filechooserbutton1);
    
    if(eu_readelf == TRUE)
    {
	strcpy(my_command,"eu-readelf ");
	if(disp_section==TRUE)
	{
		strcat(my_command,"-S ");
	}
	if(disp_symbol==TRUE)
	{
		strcat(my_command,"-s ");
	}
	my_params=gtk_entry_get_text(param);
	if(my_params !=NULL)
	{
		strcat(my_command,my_params);
	}
	strcat(my_command,"  ");
	strcat(my_command,filename);
    }
    else
    {
	//use my elf parser ;)
	//for the timebeing it is hard coded
	strcpy(my_command,"elfinfo ");
	strcat(my_command,filename);
	if(disp_section==TRUE)
	{
		strcat(my_command," section ");
	}
	if( disp_symbol==TRUE)
	{
		strcat(my_command," symbol ");
	}
    }
    
    
    printf("%s",my_command);
    gchar *my_line=(gchar *)malloc(sizeof(gchar)*1024);
    fp= popen(my_command,"r");
    if (fp == NULL)
    {
	printf("Error: Unable to spawn process\n");
	return;
    }
    
    fd=fileno(fp);
    if(fd==-1) return;
    my_channel=g_io_channel_unix_new(fd); //stdout
    if(my_channel == NULL)
    {
	printf("Error: Unable to open IO channel\n");
	return;
    }
    
    while (stat=g_io_channel_read_line(my_channel, &my_line, &length,NULL, NULL)==G_IO_STATUS_NORMAL)
    {
	gtk_text_buffer_insert_at_cursor(buffer,my_line,length);
    }
    
    gtk_text_buffer_insert_at_cursor(buffer,"\nFinished\0",-1);
    g_io_channel_shutdown(my_channel,TRUE,NULL);
    g_io_channel_unref( my_channel);
}


gboolean
on_window1_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  printf("Good Bye...!\n");
  gtk_main_quit();
  return FALSE;
}

void
on_quit_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_main_quit();
}

void
on_filechooserbutton1_selection_changed
                                        (GtkFileChooser  *filechooser,
                                        gpointer         user_data)
{
	char *filename;
	filename=malloc(sizeof(char)*strlen(gtk_file_chooser_get_filename(filechooser)+1));
	filename=gtk_file_chooser_get_filename(filechooser);
	printf("%s\n",filename);
	gtk_text_buffer_set_text((GtkTextBuffer *)user_data," \0",-1);
	
	gtk_text_buffer_insert_at_cursor((GtkTextBuffer*)user_data,filename,-1);
	
}


